=== debian/changelog ===
warzone2100 (3.3.0-4) unstable; urgency=medium

  * Team upload.
  * Remove wkhtmltopdf from Build-Depends and explain how to build the
    pdf documentation from source in README.source.
    This is currently necessary to prevent a FTBFS on mipsel. However the pdf
    documentation can be rebuilt on all other supported architectures and the
    same guide is also already available in html.

 -- Markus Koschany <apo@debian.org>  Sat, 17 Oct 2020 00:11:13 +0200

warzone2100 (3.3.0-3) unstable; urgency=medium

  * Team upload.
  * Add wkhtmltopdf.patch and grant wkhtmltopdf access to local files in order
    to prevent a FTBFS. (Closes: #971194)
  * Switch to debhelper-compat = 13.
  * Declare compliance with Debian Policy 4.5.0.
  * Install the appdata file.

 -- Markus Koschany <apo@debian.org>  Tue, 06 Oct 2020 22:57:35 +0200

warzone2100 (3.3.0-2) unstable; urgency=medium

  * Build-depend on libharfbuzz-dev  Closes: #953351
  * Added myself to the uploaders.
  * NB wkhtmltopdf needs execmem access to run without SEGV.

 -- Russell Coker <russell@coker.com.au>  Tue, 10 Mar 2020 00:24:48 +1100

warzone2100 (3.3.0-1) unstable; urgency=medium

  * New upstream version with NullBot as default AI among many other changes.
    Save game format is incompatible with 3.2.x.
  * Build depend on wkhtmltopdf for wkhtmltopdf command to make pdf from html
  * Remove quickstartguide.patch as we need to build some pdfs because
    upstream doesn't ship them.
  * Build depend on libglm-dev so we don't need 3rdparty/glm
  * Added an excessive number of rules to debian/source/options, maybe some
    changes to the build commands are needed to deal with this.
  * doc/Readme.en is no longer in the upstream tarball.
  * Uploaded with approval of Markus.

 -- Russell Coker <russell@coker.com.au>  Sun, 08 Mar 2020 11:51:04 +1100

warzone2100 (3.2.1-4) unstable; urgency=medium

  * Team upload.
  * Move the package to salsa.debian.org.
  * Fix segmentation fault upon multiplayer "Start Hosting Game"
    Thanks to Phil Morrell for the report and Bernhard Übelacker for the patch.
    (Closes: #930942)

 -- Markus Koschany <apo@debian.org>  Wed, 26 Jun 2019 06:49:41 +0200
